//=============================================================================
//
// file :        IntlkGun.h
//
// description : Include for the IntlkGun class.
//
// project :	
//
// $Author: graziano $
//
// $Revision: 1.8 $
//
// $Log: IntlkGun.h,v $
// Revision 1.8  2019-01-07 15:21:34  graziano
// fixed for upgrade of plc interlock booster
//
// Revision 1.7  2017-03-30 11:34:28  claudio
// ticket 1934 porting to tango-9
//
// Revision 1.6  2013-08-26 10:35:52  claudio
// Device_4Impl for tango-8
//
// Revision 1.5  2008-08-11 10:29:15  sara
// cached attributes
//
// Revision 1.4  2008/03/31 14:43:07  sara
// updated signal names
//
// Revision 1.3  2008/03/20 10:57:12  sara
// Changed signals access control 1 and 2 to single signal CONTROLLO_ACCESSI
//
// Revision 1.2  2008/02/01 14:20:21  sara
// added RealFilTimer attribute for gun current timer bar
//
// Revision 1.1.1.1  2007/08/31 16:24:36  sara
// server for gun interlock
//
//
// copyleft :    European Synchrotron Radiation Facility
//               BP 220, Grenoble 38043
//               FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================
#ifndef _INTLKGUN_H
#define _INTLKGUN_H

#include <tango.h>
#include <math.h>
#include <stdlib.h>
#include <sys/time.h>
//using namespace Tango;

/**
 * @author	$Author: graziano $
 * @version	$Revision: 1.8 $
 */

 //	Add your own constants definitions here.
 //-----------------------------------------------


namespace IntlkGun_ns
{
//number of bits in the message from low level interlock server (attr db_50)
#define	MESG_50_LEN_B	3200
//size of db53 in bit (attr rt_db_53)
#define	MESG_53_LEN_B	3200
//size of raw_msg_50 
#define	RAW_MSG_50_LEN	410
//size of raw_msg_10 
#define	RAW_MSG_10_LEN	26

//attribute cache refresh period in us 
#define RFSH_CACHE   1000000 

//length of attributes in bit
#define	GUNSAFETY_DIM	8
#define	FILABI_DIM	2
#define	FILCURR_DIM	1
#define	FILREADY_DIM	6
#define	GUNHV_DIM	10
#define	ABITRIGGUN_DIM	1

/**
 * Class Description:
 * 
 */

/*
 *	Device States Description:
*  Tango::ON :
*  Tango::FAULT :
 */


class IntlkGun: public TANGO_BASE_CLASS
{
public :
	//	Add your own data members here
	//-----------------------------------------


	//	Here is the Start of the automatic code generation part
	//-------------------------------------------------------------	
/**
 *	@name attributes
 *	Attributs member data.
 */
//@{
		Tango::DevDouble	*attr_CurrFilVal_read;
		Tango::DevDouble	*attr_GridVal_read;
		Tango::DevUShort	*attr_FilTimer_read;
		Tango::DevFloat	*attr_RealFilTimer_read;
		Tango::DevBoolean	*attr_GunSafety_read;
		Tango::DevBoolean	*attr_FilAbi_read;
		Tango::DevBoolean	*attr_FilCurr_read;
		Tango::DevBoolean	*attr_FilReady_read;
		Tango::DevBoolean	*attr_GunHv_read;
		Tango::DevBoolean	*attr_AbiTrigGun_read;
		Tango::DevBoolean	*attr_AlmGunSafety_read;
		Tango::DevBoolean	attr_AlmGunSafety_write;
		Tango::DevBoolean	*attr_AlmFilAbi_read;
		Tango::DevBoolean	attr_AlmFilAbi_write;
		Tango::DevBoolean	*attr_AlmFilCurr_read;
		Tango::DevBoolean	attr_AlmFilCurr_write;
		Tango::DevBoolean	*attr_AlmFilReady_read;
		Tango::DevBoolean	attr_AlmFilReady_write;
		Tango::DevBoolean	*attr_AlmGunHV_read;
		Tango::DevBoolean	attr_AlmGunHV_write;
		Tango::DevBoolean	*attr_AlmAbiTrigGun_read;
//@}

/**
 *	@name Device properties
 *	Device properties member data.
 */
//@{
/**
 *	
 */
	string	intlk_srv;
//@}

/**@name Constructors
 * Miscellaneous constructors */
//@{
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	IntlkGun(Tango::DeviceClass *cl,string &s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	IntlkGun(Tango::DeviceClass *cl,const char *s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device name
 *	@param d	Device description.
 */
	IntlkGun(Tango::DeviceClass *cl,const char *s,const char *d);
//@}

/**@name Destructor
 * Only one desctructor is defined for this class */
//@{
/**
 * The object desctructor.
 */	
	~IntlkGun() {delete_device();};
/**
 *	will be called at device destruction or at init command.
 */
	void delete_device();
//@}

	
/**@name Miscellaneous methods */
//@{
/**
 *	Initialize the device
 */
	virtual void init_device();
/**
 *	Always executed method befor execution command method.
 */
	virtual void always_executed_hook();

//@}

/**
 * @name IntlkGun methods prototypes
 */

//@{
/**
 *	Hardware acquisition for attributes.
 */
	virtual void read_attr_hardware(vector<long> &attr_list);
/**
 *	Extract real attribute values for CurrFilVal acquisition result.
 */
	virtual void read_CurrFilVal(Tango::Attribute &attr);
/**
 *	Extract real attribute values for GridVal acquisition result.
 */
	virtual void read_GridVal(Tango::Attribute &attr);
/**
 *	Extract real attribute values for FilTimer acquisition result.
 */
	virtual void read_FilTimer(Tango::Attribute &attr);
/**
 *	Extract real attribute values for RealFilTimer acquisition result.
 */
	virtual void read_RealFilTimer(Tango::Attribute &attr);
/**
 *	Extract real attribute values for GunSafety acquisition result.
 */
	virtual void read_GunSafety(Tango::Attribute &attr);
/**
 *	Extract real attribute values for FilAbi acquisition result.
 */
	virtual void read_FilAbi(Tango::Attribute &attr);
/**
 *	Extract real attribute values for FilCurr acquisition result.
 */
	virtual void read_FilCurr(Tango::Attribute &attr);
/**
 *	Extract real attribute values for FilReady acquisition result.
 */
	virtual void read_FilReady(Tango::Attribute &attr);
/**
 *	Extract real attribute values for GunHv acquisition result.
 */
	virtual void read_GunHv(Tango::Attribute &attr);
/**
 *	Extract real attribute values for AbiTrigGun acquisition result.
 */
	virtual void read_AbiTrigGun(Tango::Attribute &attr);
/**
 *	Extract real attribute values for AlmGunSafety acquisition result.
 */
	virtual void read_AlmGunSafety(Tango::Attribute &attr);
/**
 *	Write AlmGunSafety attribute values to hardware.
 */
	virtual void write_AlmGunSafety(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for AlmFilAbi acquisition result.
 */
	virtual void read_AlmFilAbi(Tango::Attribute &attr);
/**
 *	Write AlmFilAbi attribute values to hardware.
 */
	virtual void write_AlmFilAbi(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for AlmFilCurr acquisition result.
 */
	virtual void read_AlmFilCurr(Tango::Attribute &attr);
/**
 *	Write AlmFilCurr attribute values to hardware.
 */
	virtual void write_AlmFilCurr(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for AlmFilReady acquisition result.
 */
	virtual void read_AlmFilReady(Tango::Attribute &attr);
/**
 *	Write AlmFilReady attribute values to hardware.
 */
	virtual void write_AlmFilReady(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for AlmGunHV acquisition result.
 */
	virtual void read_AlmGunHV(Tango::Attribute &attr);
/**
 *	Write AlmGunHV attribute values to hardware.
 */
	virtual void write_AlmGunHV(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for AlmAbiTrigGun acquisition result.
 */
	virtual void read_AlmAbiTrigGun(Tango::Attribute &attr);
/**
 *	Read/Write allowed for CurrFilVal attribute.
 */
	virtual bool is_CurrFilVal_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for GridVal attribute.
 */
	virtual bool is_GridVal_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for FilTimer attribute.
 */
	virtual bool is_FilTimer_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for RealFilTimer attribute.
 */
	virtual bool is_RealFilTimer_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for GunSafety attribute.
 */
	virtual bool is_GunSafety_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for FilAbi attribute.
 */
	virtual bool is_FilAbi_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for FilCurr attribute.
 */
	virtual bool is_FilCurr_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for FilReady attribute.
 */
	virtual bool is_FilReady_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for GunHv attribute.
 */
	virtual bool is_GunHv_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for AbiTrigGun attribute.
 */
	virtual bool is_AbiTrigGun_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for AlmGunSafety attribute.
 */
	virtual bool is_AlmGunSafety_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for AlmFilAbi attribute.
 */
	virtual bool is_AlmFilAbi_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for AlmFilCurr attribute.
 */
	virtual bool is_AlmFilCurr_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for AlmFilReady attribute.
 */
	virtual bool is_AlmFilReady_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for AlmGunHV attribute.
 */
	virtual bool is_AlmGunHV_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for AlmAbiTrigGun attribute.
 */
	virtual bool is_AlmAbiTrigGun_allowed(Tango::AttReqType type);
/**
 *	Execution allowed for Acknowledge_all command.
 */
	virtual bool is_Acknowledge_all_allowed(const CORBA::Any &any);
/**
 * 
 *	@exception DevFailed
 */
	void	acknowledge_all();

/**
 *	Read the device properties from database
 */
	 void get_device_property();
//@}

	//	Here is the end of the automatic code generation part
	//-------------------------------------------------------------	



protected :	
	//	Add your own data members here
	//-----------------------------------------
	Tango::DeviceProxy *devintlk;
	Tango::DevBoolean	msg_50[MESG_50_LEN_B];
	Tango::DevBoolean	msg_53[MESG_53_LEN_B];
//	Tango::DevShort		rawmsg_50[RAW_MSG_50_LEN];
	Tango::DevDouble	rawmsg_10[RAW_MSG_10_LEN];

	Tango::DevBoolean	gun_safety[GUNSAFETY_DIM];
	short int	pos_gun_safety[GUNSAFETY_DIM];
	Tango::DevString	name_gun_safety[GUNSAFETY_DIM];
	Tango::DevBoolean	alm_gun_safety[GUNSAFETY_DIM];
	short int	pos_alm_gun_safety[GUNSAFETY_DIM];
	Tango::DevString	name_alm_gun_safety[GUNSAFETY_DIM];

	Tango::DevBoolean	fil_abi[FILABI_DIM];
	short int	pos_fil_abi[FILABI_DIM];
	Tango::DevString	name_fil_abi[FILABI_DIM];
	Tango::DevBoolean	alm_fil_abi[FILABI_DIM];
	short int	pos_alm_fil_abi[FILABI_DIM];
	Tango::DevString	name_alm_fil_abi[FILABI_DIM];

	Tango::DevBoolean	fil_curr[FILCURR_DIM];
	short int	pos_fil_curr[FILCURR_DIM];
	Tango::DevString	name_fil_curr[FILCURR_DIM];
	Tango::DevBoolean	alm_fil_curr[FILCURR_DIM];
	short int	pos_alm_fil_curr[FILCURR_DIM];
	Tango::DevString	name_alm_fil_curr[FILCURR_DIM];

	Tango::DevBoolean	fil_ready[FILREADY_DIM];
	short int	pos_fil_ready[FILREADY_DIM];
	Tango::DevString	name_fil_ready[FILREADY_DIM];
	Tango::DevBoolean	alm_fil_ready[FILREADY_DIM];
	short int	pos_alm_fil_ready[FILREADY_DIM];
	Tango::DevString	name_alm_fil_ready[FILREADY_DIM];

	Tango::DevBoolean	gun_hv[GUNHV_DIM];
	short int	pos_gun_hv[GUNHV_DIM];
	Tango::DevString	name_gun_hv[GUNHV_DIM];
	Tango::DevBoolean	alm_gun_hv[GUNHV_DIM];
	short int	pos_alm_gun_hv[GUNHV_DIM];
	Tango::DevString	name_alm_gun_hv[GUNHV_DIM];

	Tango::DevBoolean	abi_trig_gun[ABITRIGGUN_DIM];
	short int	pos_abi_trig_gun[ABITRIGGUN_DIM];
	Tango::DevString	name_abi_trig_gun[ABITRIGGUN_DIM];
	Tango::DevBoolean	alm_abi_trig_gun[ABITRIGGUN_DIM];
	short int	pos_alm_abi_trig_gun[ABITRIGGUN_DIM];
	Tango::DevString	name_alm_abi_trig_gun[ABITRIGGUN_DIM];

	Tango::DevDouble	curr_fil_val;
	Tango::DevDouble	grid_val;
	Tango::DevUShort	fil_timer;
	Tango::DevFloat		real_fil_timer;

	double timestamp_50;
	double timestamp_53;

	void match_labels(const char* dbn);
	struct timeval last_cache_update;
};

}	// namespace_ns

#endif	// _INTLKGUN_H
