static const char *RcsId     = "$Header: /home/cvsadm/cvsroot/booster/servers/interlock/gunintlk/src/IntlkGunClass.cpp,v 1.4 2017-07-31 12:16:45 claudio Exp $";
static const char *TagName   = "$Name:  $";
static const char *HttpServer= "http://www.esrf.fr/computing/cs/tango/tango_doc/ds_doc/";
//+=============================================================================
//
// file :        IntlkGunClass.cpp
//
// description : C++ source for the IntlkGunClass. A singleton
//               class derived from DeviceClass. It implements the
//               command list and all properties and methods required
//               by the IntlkGun once per process.
//
// project :     TANGO Device Server
//
// $Author: claudio $
//
// $Revision: 1.4 $
//
// $Log: IntlkGunClass.cpp,v $
// Revision 1.4  2017-07-31 12:16:45  claudio
// ticket #1554: porting to tango-9.2.5.a/QTANGO_BASE_CLASS
//
// Revision 1.3  2013-08-26 10:35:52  claudio
// Device_4Impl for tango-8
//
// Revision 1.2  2008-02-01 14:20:21  sara
// added RealFilTimer attribute for gun current timer bar
//
// Revision 1.1.1.1  2007/08/31 16:24:36  sara
// server for gun interlock
//
//
// copyleft :   European Synchrotron Radiation Facility
//              BP 220, Grenoble 38043
//              FRANCE
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================


#include <tango.h>

#include <IntlkGun.h>
#include <IntlkGunClass.h>


//+----------------------------------------------------------------------------
/**
 *	Create IntlkGunClass singleton and return it in a C function for Python usage
 */
//+----------------------------------------------------------------------------
extern "C" {
#ifdef WIN32

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_IntlkGun_class(const char *name) {
		return IntlkGun_ns::IntlkGunClass::init(name);
	}
}


namespace IntlkGun_ns
{
//+----------------------------------------------------------------------------
//
// method : 		Acknowledge_allClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Acknowledge_allClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Acknowledge_allClass::execute(): arrived" << endl;

	((static_cast<IntlkGun *>(device))->acknowledge_all());
	return new CORBA::Any();
}



//
//----------------------------------------------------------------
//	Initialize pointer for singleton pattern
//----------------------------------------------------------------
//
IntlkGunClass *IntlkGunClass::_instance = NULL;

//+----------------------------------------------------------------------------
//
// method : 		IntlkGunClass::IntlkGunClass(string &s)
// 
// description : 	constructor for the IntlkGunClass
//
// in : - s : The class name
//
//-----------------------------------------------------------------------------
IntlkGunClass::IntlkGunClass(string &s):DeviceClass(s)
{

	cout2 << "Entering IntlkGunClass constructor" << endl;
	set_default_property();
	get_class_property();
	write_class_property();
	
	cout2 << "Leaving IntlkGunClass constructor" << endl;

}
//+----------------------------------------------------------------------------
//
// method : 		IntlkGunClass::~IntlkGunClass()
// 
// description : 	destructor for the IntlkGunClass
//
//-----------------------------------------------------------------------------
IntlkGunClass::~IntlkGunClass()
{
	_instance = NULL;
}

//+----------------------------------------------------------------------------
//
// method : 		IntlkGunClass::instance
// 
// description : 	Create the object if not already done. Otherwise, just
//			return a pointer to the object
//
// in : - name : The class name
//
//-----------------------------------------------------------------------------
IntlkGunClass *IntlkGunClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new IntlkGunClass(s);
		}
		catch (bad_alloc)
		{
			throw;
		}		
	}		
	return _instance;
}

IntlkGunClass *IntlkGunClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}

//+----------------------------------------------------------------------------
//
// method : 		IntlkGunClass::command_factory
// 
// description : 	Create the command object(s) and store them in the 
//			command list
//
//-----------------------------------------------------------------------------
void IntlkGunClass::command_factory()
{
	command_list.push_back(new Acknowledge_allClass("Acknowledge_all",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));

	//	add polling if any
	for (unsigned int i=0 ; i<command_list.size(); i++)
	{
	}
}

//+----------------------------------------------------------------------------
//
// method : 		IntlkGunClass::get_class_property
// 
// description : 	Get the class property for specified name.
//
// in :		string	name : The property name
//
//+----------------------------------------------------------------------------
Tango::DbDatum IntlkGunClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		IntlkGunClass::get_default_device_property()
// 
// description : 	Return the default value for device property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum IntlkGunClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//+----------------------------------------------------------------------------
//
// method : 		IntlkGunClass::get_default_class_property()
// 
// description : 	Return the default value for class property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum IntlkGunClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		IntlkGunClass::device_factory
// 
// description : 	Create the device object(s) and store them in the 
//			device list
//
// in :		Tango::DevVarStringArray *devlist_ptr : The device name list
//
//-----------------------------------------------------------------------------
void IntlkGunClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{

	//	Create all devices.(Automatic code generation)
	//-------------------------------------------------------------
	for (unsigned long i=0 ; i < devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
						
		// Create devices and add it into the device list
		//----------------------------------------------------
		device_list.push_back(new IntlkGun(this, (*devlist_ptr)[i]));							 

		// Export device to the outside world
		// Check before if database used.
		//---------------------------------------------
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(device_list.back());
		else
			export_device(device_list.back(), (*devlist_ptr)[i]);
	}
	//	End of Automatic code generation
	//-------------------------------------------------------------

}
//+----------------------------------------------------------------------------
//	Method: IntlkGunClass::attribute_factory(vector<Tango::Attr *> &att_list)
//-----------------------------------------------------------------------------
void IntlkGunClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	//	Attribute : CurrFilVal
	CurrFilValAttrib	*curr_fil_val = new CurrFilValAttrib();
	att_list.push_back(curr_fil_val);

	//	Attribute : GridVal
	GridValAttrib	*grid_val = new GridValAttrib();
	att_list.push_back(grid_val);

	//	Attribute : FilTimer
	FilTimerAttrib	*fil_timer = new FilTimerAttrib();
	att_list.push_back(fil_timer);

	//	Attribute : RealFilTimer
	RealFilTimerAttrib	*real_fil_timer = new RealFilTimerAttrib();
	att_list.push_back(real_fil_timer);

	//	Attribute : GunSafety
	GunSafetyAttrib	*gun_safety = new GunSafetyAttrib();
	att_list.push_back(gun_safety);

	//	Attribute : FilAbi
	FilAbiAttrib	*fil_abi = new FilAbiAttrib();
	att_list.push_back(fil_abi);

	//	Attribute : FilCurr
	FilCurrAttrib	*fil_curr = new FilCurrAttrib();
	att_list.push_back(fil_curr);

	//	Attribute : FilReady
	FilReadyAttrib	*fil_ready = new FilReadyAttrib();
	att_list.push_back(fil_ready);

	//	Attribute : GunHv
	GunHvAttrib	*gun_hv = new GunHvAttrib();
	att_list.push_back(gun_hv);

	//	Attribute : AbiTrigGun
	AbiTrigGunAttrib	*abi_trig_gun = new AbiTrigGunAttrib();
	att_list.push_back(abi_trig_gun);

	//	Attribute : AlmGunSafety
	AlmGunSafetyAttrib	*alm_gun_safety = new AlmGunSafetyAttrib();
	att_list.push_back(alm_gun_safety);

	//	Attribute : AlmFilAbi
	AlmFilAbiAttrib	*alm_fil_abi = new AlmFilAbiAttrib();
	att_list.push_back(alm_fil_abi);

	//	Attribute : AlmFilCurr
	AlmFilCurrAttrib	*alm_fil_curr = new AlmFilCurrAttrib();
	att_list.push_back(alm_fil_curr);

	//	Attribute : AlmFilReady
	AlmFilReadyAttrib	*alm_fil_ready = new AlmFilReadyAttrib();
	att_list.push_back(alm_fil_ready);

	//	Attribute : AlmGunHV
	AlmGunHVAttrib	*alm_gun_hv = new AlmGunHVAttrib();
	att_list.push_back(alm_gun_hv);

	//	Attribute : AlmAbiTrigGun
	AlmAbiTrigGunAttrib	*alm_abi_trig_gun = new AlmAbiTrigGunAttrib();
	att_list.push_back(alm_abi_trig_gun);

	//	End of Automatic code generation
	//-------------------------------------------------------------
}

//+----------------------------------------------------------------------------
//
// method : 		IntlkGunClass::get_class_property()
// 
// description : 	Read the class properties from database.
//
//-----------------------------------------------------------------------------
void IntlkGunClass::get_class_property()
{
	//	Initialize your default values here (if not done with  POGO).
	//------------------------------------------------------------------

	//	Read class properties from database.(Automatic code generation)
	//------------------------------------------------------------------

	//	Call database and extract values
	//--------------------------------------------
	if (Tango::Util::instance()->_UseDb==true)
		get_db_class()->get_property(cl_prop);
	Tango::DbDatum	def_prop;
	int	i = -1;


	//	End of Automatic code generation
	//------------------------------------------------------------------

}

//+----------------------------------------------------------------------------
//
// method : 	IntlkGunClass::set_default_property
// 
// description: Set default property (class and device) for wizard.
//              For each property, add to wizard property name and description
//              If default value has been set, add it to wizard property and
//              store it in a DbDatum.
//
//-----------------------------------------------------------------------------
void IntlkGunClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;

	vector<string>	vect_data;
	//	Set Default Class Properties
	//	Set Default Device Properties
	prop_name = "Intlk_srv";
	prop_desc = "";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

}
//+----------------------------------------------------------------------------
//
// method : 		IntlkGunClass::write_class_property
// 
// description : 	Set class description as property in database
//
//-----------------------------------------------------------------------------
void IntlkGunClass::write_class_property()
{
	//	First time, check if database used
	//--------------------------------------------
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("  ");
	description << str_desc;
	data.push_back(description);
		
	//	put cvs location
	string	rcsId(RcsId);
	string	filename(classname);
	start = rcsId.find("/");
	if (start!=string::npos)
	{
		filename += "Class.cpp";
		end   = rcsId.find(filename);
		if (end>start)
		{
			string	strloc = rcsId.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}

	//	Get CVS tag revision
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("Device_4Impl");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	//--------------------------------------------
	get_db_class()->put_property(data);
}

}	// namespace
