//=============================================================================
//
// file :         IntlkGunClass.h
//
// description :  Include for the IntlkGunClass root class.
//                This class is represents the singleton class for
//                the IntlkGun device class.
//                It contains all properties and methods which the 
//                IntlkGun requires only once e.g. the commands.
//			
// project :      TANGO Device Server
//
// $Author: sara $
//
// $Revision: 1.2 $
//
// $Log: IntlkGunClass.h,v $
// Revision 1.2  2008-02-01 14:20:21  sara
// added RealFilTimer attribute for gun current timer bar
//
// Revision 1.1.1.1  2007/08/31 16:24:36  sara
// server for gun interlock
//
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#ifndef _INTLKGUNCLASS_H
#define _INTLKGUNCLASS_H

#include <tango.h>
#include <IntlkGun.h>


namespace IntlkGun_ns
{//=====================================
//	Define classes for attributes
//=====================================
class AlmAbiTrigGunAttrib: public Tango::SpectrumAttr
{
public:
	AlmAbiTrigGunAttrib():SpectrumAttr("AlmAbiTrigGun", Tango::DEV_BOOLEAN, Tango::READ, 1) {};
	~AlmAbiTrigGunAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<IntlkGun *>(dev))->read_AlmAbiTrigGun(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<IntlkGun *>(dev))->is_AlmAbiTrigGun_allowed(ty);}
};

class AlmGunHVAttrib: public Tango::SpectrumAttr
{
public:
	AlmGunHVAttrib():SpectrumAttr("AlmGunHV", Tango::DEV_BOOLEAN, Tango::READ_WRITE, 10) {};
	~AlmGunHVAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<IntlkGun *>(dev))->read_AlmGunHV(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<IntlkGun *>(dev))->write_AlmGunHV(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<IntlkGun *>(dev))->is_AlmGunHV_allowed(ty);}
};

class AlmFilReadyAttrib: public Tango::SpectrumAttr
{
public:
	AlmFilReadyAttrib():SpectrumAttr("AlmFilReady", Tango::DEV_BOOLEAN, Tango::READ_WRITE, 6) {};
	~AlmFilReadyAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<IntlkGun *>(dev))->read_AlmFilReady(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<IntlkGun *>(dev))->write_AlmFilReady(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<IntlkGun *>(dev))->is_AlmFilReady_allowed(ty);}
};

class AlmFilCurrAttrib: public Tango::SpectrumAttr
{
public:
	AlmFilCurrAttrib():SpectrumAttr("AlmFilCurr", Tango::DEV_BOOLEAN, Tango::READ_WRITE, 1) {};
	~AlmFilCurrAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<IntlkGun *>(dev))->read_AlmFilCurr(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<IntlkGun *>(dev))->write_AlmFilCurr(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<IntlkGun *>(dev))->is_AlmFilCurr_allowed(ty);}
};

class AlmFilAbiAttrib: public Tango::SpectrumAttr
{
public:
	AlmFilAbiAttrib():SpectrumAttr("AlmFilAbi", Tango::DEV_BOOLEAN, Tango::READ_WRITE, 2) {};
	~AlmFilAbiAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<IntlkGun *>(dev))->read_AlmFilAbi(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<IntlkGun *>(dev))->write_AlmFilAbi(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<IntlkGun *>(dev))->is_AlmFilAbi_allowed(ty);}
};

class AlmGunSafetyAttrib: public Tango::SpectrumAttr
{
public:
	AlmGunSafetyAttrib():SpectrumAttr("AlmGunSafety", Tango::DEV_BOOLEAN, Tango::READ_WRITE, 8) {};
	~AlmGunSafetyAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<IntlkGun *>(dev))->read_AlmGunSafety(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<IntlkGun *>(dev))->write_AlmGunSafety(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<IntlkGun *>(dev))->is_AlmGunSafety_allowed(ty);}
};

class AbiTrigGunAttrib: public Tango::SpectrumAttr
{
public:
	AbiTrigGunAttrib():SpectrumAttr("AbiTrigGun", Tango::DEV_BOOLEAN, Tango::READ, 1) {};
	~AbiTrigGunAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<IntlkGun *>(dev))->read_AbiTrigGun(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<IntlkGun *>(dev))->is_AbiTrigGun_allowed(ty);}
};

class GunHvAttrib: public Tango::SpectrumAttr
{
public:
	GunHvAttrib():SpectrumAttr("GunHv", Tango::DEV_BOOLEAN, Tango::READ, 10) {};
	~GunHvAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<IntlkGun *>(dev))->read_GunHv(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<IntlkGun *>(dev))->is_GunHv_allowed(ty);}
};

class FilReadyAttrib: public Tango::SpectrumAttr
{
public:
	FilReadyAttrib():SpectrumAttr("FilReady", Tango::DEV_BOOLEAN, Tango::READ, 6) {};
	~FilReadyAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<IntlkGun *>(dev))->read_FilReady(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<IntlkGun *>(dev))->is_FilReady_allowed(ty);}
};

class FilCurrAttrib: public Tango::SpectrumAttr
{
public:
	FilCurrAttrib():SpectrumAttr("FilCurr", Tango::DEV_BOOLEAN, Tango::READ, 2) {};
	~FilCurrAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<IntlkGun *>(dev))->read_FilCurr(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<IntlkGun *>(dev))->is_FilCurr_allowed(ty);}
};

class FilAbiAttrib: public Tango::SpectrumAttr
{
public:
	FilAbiAttrib():SpectrumAttr("FilAbi", Tango::DEV_BOOLEAN, Tango::READ, 2) {};
	~FilAbiAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<IntlkGun *>(dev))->read_FilAbi(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<IntlkGun *>(dev))->is_FilAbi_allowed(ty);}
};

class GunSafetyAttrib: public Tango::SpectrumAttr
{
public:
	GunSafetyAttrib():SpectrumAttr("GunSafety", Tango::DEV_BOOLEAN, Tango::READ, 8) {};
	~GunSafetyAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<IntlkGun *>(dev))->read_GunSafety(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<IntlkGun *>(dev))->is_GunSafety_allowed(ty);}
};

class RealFilTimerAttrib: public Tango::Attr
{
public:
	RealFilTimerAttrib():Attr("RealFilTimer", Tango::DEV_FLOAT, Tango::READ) {};
	~RealFilTimerAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<IntlkGun *>(dev))->read_RealFilTimer(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<IntlkGun *>(dev))->is_RealFilTimer_allowed(ty);}
};

class FilTimerAttrib: public Tango::Attr
{
public:
	FilTimerAttrib():Attr("FilTimer", Tango::DEV_USHORT, Tango::READ) {};
	~FilTimerAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<IntlkGun *>(dev))->read_FilTimer(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<IntlkGun *>(dev))->is_FilTimer_allowed(ty);}
};

class GridValAttrib: public Tango::Attr
{
public:
	GridValAttrib():Attr("GridVal", Tango::DEV_DOUBLE, Tango::READ) {};
	~GridValAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<IntlkGun *>(dev))->read_GridVal(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<IntlkGun *>(dev))->is_GridVal_allowed(ty);}
};

class CurrFilValAttrib: public Tango::Attr
{
public:
	CurrFilValAttrib():Attr("CurrFilVal", Tango::DEV_DOUBLE, Tango::READ) {};
	~CurrFilValAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<IntlkGun *>(dev))->read_CurrFilVal(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<IntlkGun *>(dev))->is_CurrFilVal_allowed(ty);}
};

//=========================================
//	Define classes for commands
//=========================================
class Acknowledge_allClass : public Tango::Command
{
public:
	Acknowledge_allClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	Acknowledge_allClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~Acknowledge_allClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<IntlkGun *>(dev))->is_Acknowledge_all_allowed(any);}
};



//
// The IntlkGunClass singleton definition
//

class IntlkGunClass : public Tango::DeviceClass
{
public:
//	properties member data

//	add your own data members here
//------------------------------------

public:
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static IntlkGunClass *init(const char *);
	static IntlkGunClass *instance();
	~IntlkGunClass();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	IntlkGunClass(string &);
	static IntlkGunClass *_instance;
	void command_factory();
	void get_class_property();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();

private:
	void device_factory(const Tango::DevVarStringArray *);
};


}	//	namespace IntlkGun_ns

#endif // _INTLKGUNCLASS_H
